// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: accelfin-server-demo-fx-dtos.proto

package com.accelfin.server.demo.fx.dtos;

/**
 * Protobuf type {@code com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto}
 */
public  final class GetHistoricalTradeResponseDto extends
    com.google.protobuf.GeneratedMessage implements
    // @@protoc_insertion_point(message_implements:com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto)
    GetHistoricalTradeResponseDtoOrBuilder {
  // Use GetHistoricalTradeResponseDto.newBuilder() to construct.
  private GetHistoricalTradeResponseDto(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
    super(builder);
  }
  private GetHistoricalTradeResponseDto() {
    trades_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return com.google.protobuf.UnknownFieldSet.getDefaultInstance();
  }
  private GetHistoricalTradeResponseDto(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    int mutable_bitField0_ = 0;
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          default: {
            if (!input.skipField(tag)) {
              done = true;
            }
            break;
          }
          case 10: {
            if (!((mutable_bitField0_ & 0x00000001) == 0x00000001)) {
              trades_ = new java.util.ArrayList<com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto>();
              mutable_bitField0_ |= 0x00000001;
            }
            trades_.add(input.readMessage(com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.parser(), extensionRegistry));
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000001) == 0x00000001)) {
        trades_ = java.util.Collections.unmodifiableList(trades_);
      }
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_GetHistoricalTradeResponseDto_descriptor;
  }

  protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_GetHistoricalTradeResponseDto_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto.class, com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto.Builder.class);
  }

  public static final int TRADES_FIELD_NUMBER = 1;
  private java.util.List<com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto> trades_;
  /**
   * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
   */
  public java.util.List<com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto> getTradesList() {
    return trades_;
  }
  /**
   * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
   */
  public java.util.List<? extends com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDtoOrBuilder> 
      getTradesOrBuilderList() {
    return trades_;
  }
  /**
   * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
   */
  public int getTradesCount() {
    return trades_.size();
  }
  /**
   * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
   */
  public com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto getTrades(int index) {
    return trades_.get(index);
  }
  /**
   * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
   */
  public com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDtoOrBuilder getTradesOrBuilder(
      int index) {
    return trades_.get(index);
  }

  private byte memoizedIsInitialized = -1;
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    for (int i = 0; i < trades_.size(); i++) {
      output.writeMessage(1, trades_.get(i));
    }
  }

  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    for (int i = 0; i < trades_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, trades_.get(i));
    }
    memoizedSize = size;
    return size;
  }

  private static final long serialVersionUID = 0L;
  public static com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessage.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * Protobuf type {@code com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessage.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto)
      com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDtoOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_GetHistoricalTradeResponseDto_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_GetHistoricalTradeResponseDto_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto.class, com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto.Builder.class);
    }

    // Construct using com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        getTradesFieldBuilder();
      }
    }
    public Builder clear() {
      super.clear();
      if (tradesBuilder_ == null) {
        trades_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
      } else {
        tradesBuilder_.clear();
      }
      return this;
    }

    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_GetHistoricalTradeResponseDto_descriptor;
    }

    public com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto getDefaultInstanceForType() {
      return com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto.getDefaultInstance();
    }

    public com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto build() {
      com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    public com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto buildPartial() {
      com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto result = new com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto(this);
      int from_bitField0_ = bitField0_;
      if (tradesBuilder_ == null) {
        if (((bitField0_ & 0x00000001) == 0x00000001)) {
          trades_ = java.util.Collections.unmodifiableList(trades_);
          bitField0_ = (bitField0_ & ~0x00000001);
        }
        result.trades_ = trades_;
      } else {
        result.trades_ = tradesBuilder_.build();
      }
      onBuilt();
      return result;
    }

    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto) {
        return mergeFrom((com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto other) {
      if (other == com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto.getDefaultInstance()) return this;
      if (tradesBuilder_ == null) {
        if (!other.trades_.isEmpty()) {
          if (trades_.isEmpty()) {
            trades_ = other.trades_;
            bitField0_ = (bitField0_ & ~0x00000001);
          } else {
            ensureTradesIsMutable();
            trades_.addAll(other.trades_);
          }
          onChanged();
        }
      } else {
        if (!other.trades_.isEmpty()) {
          if (tradesBuilder_.isEmpty()) {
            tradesBuilder_.dispose();
            tradesBuilder_ = null;
            trades_ = other.trades_;
            bitField0_ = (bitField0_ & ~0x00000001);
            tradesBuilder_ = 
              com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                 getTradesFieldBuilder() : null;
          } else {
            tradesBuilder_.addAllMessages(other.trades_);
          }
        }
      }
      onChanged();
      return this;
    }

    public final boolean isInitialized() {
      return true;
    }

    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }
    private int bitField0_;

    private java.util.List<com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto> trades_ =
      java.util.Collections.emptyList();
    private void ensureTradesIsMutable() {
      if (!((bitField0_ & 0x00000001) == 0x00000001)) {
        trades_ = new java.util.ArrayList<com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto>(trades_);
        bitField0_ |= 0x00000001;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilder<
        com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto, com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.Builder, com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDtoOrBuilder> tradesBuilder_;

    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public java.util.List<com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto> getTradesList() {
      if (tradesBuilder_ == null) {
        return java.util.Collections.unmodifiableList(trades_);
      } else {
        return tradesBuilder_.getMessageList();
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public int getTradesCount() {
      if (tradesBuilder_ == null) {
        return trades_.size();
      } else {
        return tradesBuilder_.getCount();
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto getTrades(int index) {
      if (tradesBuilder_ == null) {
        return trades_.get(index);
      } else {
        return tradesBuilder_.getMessage(index);
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public Builder setTrades(
        int index, com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto value) {
      if (tradesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureTradesIsMutable();
        trades_.set(index, value);
        onChanged();
      } else {
        tradesBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public Builder setTrades(
        int index, com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.Builder builderForValue) {
      if (tradesBuilder_ == null) {
        ensureTradesIsMutable();
        trades_.set(index, builderForValue.build());
        onChanged();
      } else {
        tradesBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public Builder addTrades(com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto value) {
      if (tradesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureTradesIsMutable();
        trades_.add(value);
        onChanged();
      } else {
        tradesBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public Builder addTrades(
        int index, com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto value) {
      if (tradesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureTradesIsMutable();
        trades_.add(index, value);
        onChanged();
      } else {
        tradesBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public Builder addTrades(
        com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.Builder builderForValue) {
      if (tradesBuilder_ == null) {
        ensureTradesIsMutable();
        trades_.add(builderForValue.build());
        onChanged();
      } else {
        tradesBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public Builder addTrades(
        int index, com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.Builder builderForValue) {
      if (tradesBuilder_ == null) {
        ensureTradesIsMutable();
        trades_.add(index, builderForValue.build());
        onChanged();
      } else {
        tradesBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public Builder addAllTrades(
        java.lang.Iterable<? extends com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto> values) {
      if (tradesBuilder_ == null) {
        ensureTradesIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, trades_);
        onChanged();
      } else {
        tradesBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public Builder clearTrades() {
      if (tradesBuilder_ == null) {
        trades_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
      } else {
        tradesBuilder_.clear();
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public Builder removeTrades(int index) {
      if (tradesBuilder_ == null) {
        ensureTradesIsMutable();
        trades_.remove(index);
        onChanged();
      } else {
        tradesBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.Builder getTradesBuilder(
        int index) {
      return getTradesFieldBuilder().getBuilder(index);
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDtoOrBuilder getTradesOrBuilder(
        int index) {
      if (tradesBuilder_ == null) {
        return trades_.get(index);  } else {
        return tradesBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public java.util.List<? extends com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDtoOrBuilder> 
         getTradesOrBuilderList() {
      if (tradesBuilder_ != null) {
        return tradesBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(trades_);
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.Builder addTradesBuilder() {
      return getTradesFieldBuilder().addBuilder(
          com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.getDefaultInstance());
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.Builder addTradesBuilder(
        int index) {
      return getTradesFieldBuilder().addBuilder(
          index, com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.getDefaultInstance());
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto trades = 1;</code>
     */
    public java.util.List<com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.Builder> 
         getTradesBuilderList() {
      return getTradesFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilder<
        com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto, com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.Builder, com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDtoOrBuilder> 
        getTradesFieldBuilder() {
      if (tradesBuilder_ == null) {
        tradesBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
            com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto, com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDto.Builder, com.accelfin.server.demo.fx.dtos.FxHistoricalTradeDtoOrBuilder>(
                trades_,
                ((bitField0_ & 0x00000001) == 0x00000001),
                getParentForChildren(),
                isClean());
        trades_ = null;
      }
      return tradesBuilder_;
    }
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }

    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }


    // @@protoc_insertion_point(builder_scope:com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto)
  }

  // @@protoc_insertion_point(class_scope:com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto)
  private static final com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto();
  }

  public static com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<GetHistoricalTradeResponseDto>
      PARSER = new com.google.protobuf.AbstractParser<GetHistoricalTradeResponseDto>() {
    public GetHistoricalTradeResponseDto parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
        return new GetHistoricalTradeResponseDto(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<GetHistoricalTradeResponseDto> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<GetHistoricalTradeResponseDto> getParserForType() {
    return PARSER;
  }

  public com.accelfin.server.demo.fx.dtos.GetHistoricalTradeResponseDto getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

